local function printhelp(p)
	CONS_Printf(p, "pvsc_setplayerskin <name/num> <player name/number 1-16> <skin ID>: set a player to a given skin")
end

local function setskin(caller,target,skin)
	R_SetPlayerSkin(target, skins[skin].name)
	if target.bot then
		target.skincolor = skins[skin].prefcolor
		target.mo.color = skins[skin].prefcolor
		target.name = skins[skin].realname
	end
end

local function setplayerskin(p,seltype,selection,skin)
	local selected_skin = tostring(skin)

	if seltype == nil or selection == nil or skin == nil then
		printhelp(p)
		return false
	end

	if seltype == "name" then
		local selected_name = string.upper(selection)
		for i=0,#players - 1 do
			if string.upper(players[i].name) == selected_name then
				setskin(p,players[i],selected_skin)
				return true
			end
		end

		CONS_Printf(p, "No player with that name found.")
		return false
	elseif seltype == "num" then
		local n = tonumber(selection)
		if n == nil or n > #players or n < 1 then
			CONS_Printf(p, "Invalid player number.")
			return false
		end

		if players[n - 1] then
			setskin(p,players[n - 1],selected_skin)
			return true
		else
			CONS_Printf(p, "No player in that slot found.")
			return false
		end
	else
		printhelp(p)
		return false
	end
end

COM_AddCommand("pvsc_setplayerskin", setplayerskin, COM_ADMIN)
