CV_RegisterVar({
	name = "pvsc_doskinban",
	defaultvalue = "No",
	flags = CV_NETVAR,
	possiblevalue = CV_YesNo,
	description = "Whether to enable character banning."
})

local banned_skins = {
}

local function ban_skin(p,skinname)
	if not skinname then CONS_Printf(p, "pvsc_banskin <skin ID>: prevent a character from being used.") return end
	if skins[skinname] == nil then return end
	banned_skins[skinname] = true
end

local function unban_skin(p,skinname)
	if not skinname then CONS_Printf(p, "pvsc_unbanskin <skin ID>: allow a character to be used.") return end
	if skins[skinname] == nil then return end
	banned_skins[skinname] = nil
end

local function clear_banlist(p)
	banned_skins = {}
end

local function list_banned_skins(p)
	local count = 0
	for k, v in pairs(banned_skins) do
		if v then
			count = count + 1
			CONS_Printf(p, skins[k].realname.." ("..k..")")
		end
	end
	if count == 0 then
		CONS_Printf(p, "No characters are currently banned.")
	end
end

COM_AddCommand("pvsc_banskin", ban_skin, COM_ADMIN)
COM_AddCommand("pvsc_unbanskin", unban_skin, COM_ADMIN)
COM_AddCommand("pvsc_clearbannedskins", clear_banlist, COM_ADMIN)
COM_AddCommand("pvsc_listbannedskins", list_banned_skins) -- normal players should be able to know this

local function setPlayerSkin(p,r)
	R_SetPlayerSkin(p, r)
	if p.bot then
		p.skincolor = skins[r].prefcolor
		p.mo.color = skins[r].prefcolor
		p.name = skins[r].realname
	end
end

local function setMobjSkin(p,r)
	p.mo.skin = skins[r].name
	p.kartspeed = skins[r].kartspeed
	p.kartweight = skins[r].kartweight
	p.charflags = skins[r].flags
	if p.bot then
		p.name = skins[r].realname
	end
end

addHook("PlayerThink", function(p)
	if CV_FindVar("pvsc_doskinban").value == 0 then return end
	if banned_skins[skins[p.skin].name] then
		local randomskin
		while true do
			randomskin = P_RandomRange(0, #skins - 1)
			if skins[randomskin] and (not banned_skins[skins[randomskin].name]) then break end
		end
		CONS_Printf(p, "That character isn't allowed! You've been set to a random allowed character.")
		setPlayerSkin(p,randomskin)
	elseif banned_skins[skins[p.mo.skin].name] then
		local randomskin
		while true do
			randomskin = P_RandomRange(0, #skins - 1)
			if skins[randomskin] and (not banned_skins[skins[randomskin].name]) then break end
		end
		setMobjSkin(p,randomskin)
	end
end)
